//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdlib.h>
#include <time.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.cpp"
#include "Unit3.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


AnsiString asMessage ;

AnsiString asForm1 ; //1-  
AnsiString asForm2 ; //2-  
AnsiString asForm3 ; //3-  

TStringList* MyList = new TStringList();
TStringList* MyDictionary = new TStringList();

float fResult ;

bool bSetTaskOrExamination = false ; //, false -  , true -  .

int iRandom = -1 ;

__int32 i32NumOfTries ;  //    2
__int32 i32NumOfSuccess ; //       - 1.
__int32 i32NumOfSuccessOne_after_another ; //  .
__int32 i32NumOfSucces20 ; //      20         .

__int32 i32ColourCount = 0 ;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  int iSize ;
  int i_loc ;


  asStartUpDir = GetCurrentDir() ;
  asFileName = asStartUpDir + "\\iv.ini" ;

  MyDictionary->LoadFromFile(asStartUpDir+"\\dict.txt") ;

//  ListBox1->Clear() ;
//  ListBox1->Items =  MyDictionary ;

  if (!FileExists(asFileName))
  {
     MyList->Clear() ;
     MyList->Add("mainlist=iv.txt;") ;
     MyList->Add("sounddir=;") ;
     MyList->Add("width=619;") ;
     MyList->Add("height=542;") ;
     MyList->Add("random=0;") ;
     MyList->SaveToFile(asStartUpDir + "\\" + "iv.ini") ;
  }

  if (FileExists(asFileName))
  {

      MyList->LoadFromFile(asFileName) ;

      Form1->Width = StrToInt(MyList->Strings[2].SubString(7, MyList->Strings[2].Length()-7)) ;
      Form1->Height = StrToInt(MyList->Strings[3].SubString(8, MyList->Strings[3].Length()-8)) ;

      if (StrToInt(MyList->Strings[4].SubString(8, MyList->Strings[4].Length()-8)) == 1 )
         Random1->Checked=true ;
      else
         Random1->Checked=false ;


      asFileName = MyList->Strings[0].SubString(10, MyList->Strings[0].Length()-10) ;
      asFileName = asStartUpDir + "\\" + asFileName ;

      asSoundsDirectory = MyList->Strings[1].SubString(10, MyList->Strings[1].Length()-10) ;

      if (asSoundsDirectory.Length()>0)   //       bSounds = true
         bSounds = true ;

      if (FileExists(asFileName))
      {
         MyList->LoadFromFile(asFileName) ;

         for (i_loc=0; i_loc<MyList->Count; i_loc++)
            if (MyList->Strings[i_loc][1] == '#')
            {
               MyList->Delete(i_loc) ;
               i_loc=0;
            }

//         ListBox1->Items = MyList ;
      }
      else
      {
         if (OpenDialog1->Execute())
            if (FileExists(OpenDialog1->FileName))
            {
               MyList->LoadFromFile(OpenDialog1->FileName) ;

                for (i_loc=0; i_loc<MyList->Count; i_loc++)
                  if (MyList->Strings[i_loc][1] == '#')
                  {
                     MyList->Delete(i_loc) ;
                     i_loc=0;
                  }

//                  ListBox1->Items = MyList ;
            }
      }

  }
  else
  {
     if (OpenDialog1->Execute())
        if (FileExists(OpenDialog1->FileName))
        {
           MyList->LoadFromFile(OpenDialog1->FileName) ;

           for (i_loc=0; i_loc<MyList->Count; i_loc++)
              if (MyList->Strings[i_loc][1] == '#')
              {
                 MyList->Delete(i_loc) ;
                 i_loc=0;
              }

//           ListBox1->Items = MyList ;
        }
  }


         if (Showresults1->Checked)
         {
             Label6->Visible = true ;
             Label7->Visible = true ;
             Label8->Visible = true ;
             Label9->Visible = true ;
         }
         else
         {
             Label6->Visible = false ;
             Label7->Visible = false ;
             Label8->Visible = false ;
             Label9->Visible = false ;
         }


}
//---------------------------------------------------------------------------


void __fastcall TForm1::Edit3KeyPress(TObject *Sender, char &Key)
{
   Check(Key) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Check(char Key)
{
   if (Key == 13)
   {
      if (!bSetTaskOrExamination)
      {
//         Edit4->SetFocus() ;
         SetTask() ;
         bSetTaskOrExamination=true ;
      }
      else
      {
         Examination() ;
         bSetTaskOrExamination=false ;
      }
   }
}

void __fastcall TForm1::SetTask()  // .
{//


   int i_loc ;
   int i1, i2 ;
   int iPossition ;

   Timer1->Enabled = false ;
   Label10->Visible = false ;
   Label3->Visible = false ;
   Label12->Visible = false ;

   SpeedButton1->Enabled = false ;
   SpeedButton2->Enabled = false ;
   SpeedButton3->Enabled = false ;


   Label1->Visible = false ;
   Label2->Visible = false ;
//   Label3->Visible = true ;

   Label11->Visible = false ;
   Label4->Visible = false ;
   Label5->Visible = false ;

   Edit1->Text="" ;
   Edit2->Text="" ;
   Edit3->Text="" ;

   Edit1->SetFocus() ;

   if (!Random1->Checked)
   {
      if (iRandom < MyList->Count-1)
         iRandom ++ ;
      else
         iRandom = 0 ;
   }

   if (Random1->Checked==true)
   {
      if (MyList->Count == 0) //     .
      {
         MyList->LoadFromFile(asFileName) ; //     .

         for (i_loc=0; i_loc<MyList->Count; i_loc++) //     
            if (MyList->Strings[i_loc][1] == '#')
            {
               MyList->Delete(i_loc) ;
               i_loc=0;
            }
       }

      randomize() ;

      iRandom = random(MyList->Count);
   }


   for (i1=1; i1<MyList->Strings[iRandom].Length(); i1++)
   {
      if (MyList->Strings[iRandom][i1] == '-')
      {
         asForm1 = MyList->Strings[iRandom].SubString(1,i1-1) ;
         break ;
      }
   }

   for (i2=i1+1; i2<MyList->Strings[iRandom].Length(); i2++)
   {
      if (MyList->Strings[iRandom][i2] == '-')
      {
         asForm2 = MyList->Strings[iRandom].SubString(i1+1,i2-i1-1) ;
         break ;
      }
   }

   asForm3 = MyList->Strings[iRandom].SubString(i2+1, MyList->Strings[iRandom].Length()-i2) ;

   if (Random1->Checked==true) //     .
      MyList->Delete(iRandom) ; //     .



   for (iPossition=1; iPossition<=MyDictionary->Count; iPossition++)
      if (MyDictionary->Strings[iPossition] == asForm1)
         break ;


   Edit4->Text = MyDictionary->Strings[iPossition-1] ;


   if (bSounds)
   {
      if (FileExists(asSoundsDirectory  + asForm1[1] + "\\" + asForm1 + ".wav"))
         SpeedButton1->Enabled = true ;

      if (FileExists(asSoundsDirectory + asForm2[1] + "\\" + asForm2 + ".wav"))
         SpeedButton2->Enabled = true ;

      if (FileExists(asSoundsDirectory + asForm3[1] + "\\" + asForm3 + ".wav"))
         SpeedButton3->Enabled = true ;
    }
    else
    {
       SpeedButton1->Enabled = false ;
       SpeedButton2->Enabled = false ;
       SpeedButton3->Enabled = false ;
    }


}
//---------------------------------------------------------------------------


void __fastcall TForm1::Examination() //  .
{

         if (Edit3->Text=="" && Edit2->Text!="")
            Edit3->Text = Edit2->Text ;

         if (asForm1 == Edit1->Text && asForm2 == Edit2->Text && asForm3 == Edit3->Text)
         {
//            Label3->Visible = false ;
            Label2->Visible = true ;

            i32NumOfSuccessOne_after_another ++ ;
            i32NumOfSucces20 ++ ;
         }
         else
         {
//            Label3->Visible = false ;
            Label1->Visible = true ;

            Label11->Caption = asForm1 ;
            Label4->Caption = asForm2 ;
            Label5->Caption = asForm3 ;

            i32NumOfSuccessOne_after_another = 0 ;
            i32NumOfSucces20 = 0 ;
         }

         if (asForm1 != Edit1->Text)
            Label11->Visible = true ;
         else
            i32NumOfSuccess++ ;

         if (asForm2 != Edit2->Text)
            Label4->Visible = true ;
         else
            i32NumOfSuccess++ ;

         if (asForm3 != Edit3->Text)
            Label5->Visible = true ;
         else
            i32NumOfSuccess++ ;

        i32NumOfTries = i32NumOfTries + 3 ;

        if (i32NumOfSucces20 == 20 && i32NumOfTries-i32NumOfSuccess > 0)
        {
           Timer1->Enabled = true ;
           i32NumOfSucces20 = 0 ;
           Label10->Visible = true ;
           Label3->Visible = true ;
           Label12->Visible = true ;
           if (i32NumOfTries-i32NumOfSuccess >= 5)
              i32NumOfTries = i32NumOfTries - 5 ;
           else
              i32NumOfTries = i32NumOfTries - (i32NumOfTries-i32NumOfSuccess) ;
        }


        fResult = (i32NumOfSuccess*100)/i32NumOfTries ;

        if (fResult>=75)
           Label7->Font->Color = clGreen ;

        if (fResult>=25 && fResult<75)
           Label7->Font->Color = clYellow ;

        if (fResult<25)
           Label7->Font->Color = clRed ;

        Label7->Caption = FloatToStr(fResult) + " %" ;

        Label6->Caption = " : " + IntToStr(i32NumOfSuccessOne_after_another) ;
        Label8->Caption = " : " + IntToStr(i32NumOfSuccess) ;
        Label9->Caption = ": " + IntToStr(i32NumOfTries-i32NumOfSuccess) ;

}

//---------------------------------------------------------------------------



void __fastcall TForm1::exit1Click(TObject *Sender)
{
//        Application->Terminate() ;
        Form1->Close() ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
int i_loc ;

         MyList->LoadFromFile(asFileName) ;

         for (i_loc=0; i_loc<MyList->Count; i_loc++)
            if (MyList->Strings[i_loc][1] == '#')
            {
               MyList->Delete(i_loc) ;
               i_loc=0;
            }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N2Click(TObject *Sender)
{

int i_loc ;

         if (OpenDialog1->Execute())
            if (FileExists(OpenDialog1->FileName))
            {
               asFileName = OpenDialog1->FileName ;
               MyList->LoadFromFile(asFileName) ;

               for (i_loc=0; i_loc<MyList->Count; i_loc++)
                  if (MyList->Strings[i_loc][1] == '#')
                  {
                     MyList->Delete(i_loc) ;
                     i_loc=0;
                  }
            }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
      MediaPlayer1->Close() ;
      MediaPlayer1->FileName = asSoundsDirectory + Edit1->Text[1] + "\\" + Edit1->Text + ".wav" ;
      MediaPlayer1->Open() ;
      MediaPlayer1->Play() ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
      MediaPlayer1->Close() ;
      MediaPlayer1->FileName = asSoundsDirectory + asForm2[1] + "\\" + asForm2 + ".wav" ;
      MediaPlayer1->Open() ;
      MediaPlayer1->Play() ;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
      MediaPlayer1->Close() ;
      MediaPlayer1->FileName = asSoundsDirectory + asForm3[1] + "\\" + asForm3 + ".wav" ;
      MediaPlayer1->Open() ;
      MediaPlayer1->Play() ;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{  // iv.ini

         MyList->Clear() ;
         asFileName = asStartUpDir + "\\" + "iv.ini" ;
         MyList->LoadFromFile(asFileName);
//         MyList->Strings[1] = "sounddir=" + asSoundsDirectory + ';';
         MyList->Strings[2] = "width=" + IntToStr(Form1->Width) + ';';
         MyList->Strings[3] = "height=" + IntToStr(Form1->Height) + ';';
         if (Random1->Checked)
            MyList->Strings[4] = "random=1;" ;
         else
            MyList->Strings[4] = "random=0;" ;
         MyList->SaveToFile(asStartUpDir + "\\" + "iv.ini") ;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::About2Click(TObject *Sender)
{
         Form2->ShowModal() ;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   i32ColourCount ++ ;

switch (i32ColourCount)
{
   case 1 :
       Label10->Font->Color = clAqua        ;
       Label3->Font->Color = clAqua        ;
       Label12->Font->Color = clAqua        ;
   break;
   case 2 :
        Label10->Font->Color = clBlue        ;
        Label3->Font->Color = clBlue        ;
        Label12->Font->Color = clBlue        ;
   break;
   case 3 :
        Label10->Font->Color = clDkGray      ;
        Label3->Font->Color = clDkGray      ;
        Label12->Font->Color = clDkGray      ;
   break;
   case 4 :
        Label10->Font->Color = clFuchsia     ;
        Label3->Font->Color = clFuchsia     ;
        Label12->Font->Color = clFuchsia     ;
   break;
   case 5 :
        Label10->Font->Color = clGreen       ;
        Label3->Font->Color = clGreen       ;
        Label12->Font->Color = clGreen       ;
   break;
   case 6 :
        Label10->Font->Color = clLime        ;
        Label3->Font->Color = clLime        ;
        Label12->Font->Color = clLime        ;
   break;
   case 7 :
        Label10->Font->Color = clLtGray      ;
        Label3->Font->Color = clLtGray      ;
        Label12->Font->Color = clLtGray      ;
   break;
   case 8 :
        Label10->Font->Color = clMaroon      ;
        Label3->Font->Color = clMaroon      ;
        Label12->Font->Color = clMaroon      ;
   break;
   case 9 :
        Label10->Font->Color = clNavy        ;
        Label3->Font->Color = clNavy        ;
        Label12->Font->Color = clNavy        ;
   break;
   case 10 :
        Label10->Font->Color = clOlive       ;
        Label3->Font->Color = clOlive       ;
        Label12->Font->Color = clOlive       ;
   break;
   case 11 :
        Label10->Font->Color = clPurple      ;
        Label3->Font->Color = clPurple      ;
        Label12->Font->Color = clPurple      ;
   break;
   case 12 :
        Label10->Font->Color = clRed         ;
        Label3->Font->Color = clRed         ;
        Label12->Font->Color = clRed         ;
   break;
   case 13 :
        Label10->Font->Color = clTeal        ;
        Label3->Font->Color = clTeal        ;
        Label12->Font->Color = clTeal        ;
   break;
   case 14 :
        Label10->Font->Color = clWhite       ;
        Label3->Font->Color = clWhite       ;
        Label12->Font->Color = clWhite       ;
   break;
   case 15 :
        Label10->Font->Color = clYellow      ;
        Label3->Font->Color = clYellow      ;
        Label12->Font->Color = clYellow      ;
       i32ColourCount = 0 ;
   break;

   }
}
//--------------------------------

void __fastcall TForm1::Edit1Change(TObject *Sender)
{
   if (Edit1->Text == asForm1 && N5->Checked)
      Edit2->SetFocus() ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit2Change(TObject *Sender)
{
   if (Edit2->Text == asForm2 && N5->Checked)
      Edit3->SetFocus() ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{
   if (Edit3->Text == asForm3 && N5->Checked)
      Check(13) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
         Form3->ShowModal() ;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Random1Click(TObject *Sender)
{
int i_loc ;

      if (Random1->Checked)
         Random1->Checked = false ;
      else
      {
         Random1->Checked = true ;

         MyList->LoadFromFile(asFileName) ;

         for (i_loc=0; i_loc<MyList->Count; i_loc++)
            if (MyList->Strings[i_loc][1] == '#')
            {
               MyList->Delete(i_loc) ;
               i_loc=0;
            }
      }
}
//---------------------------------------------------------------------------




void __fastcall TForm1::N5Click(TObject *Sender)
{
         if (N5->Checked)
            N5->Checked = false ;
         else
            N5->Checked = true ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Showresults1Click(TObject *Sender)
{

   Showresults1->Checked = !Showresults1->Checked ;


         if (Showresults1->Checked)
         {
             Label6->Visible = true ;
             Label7->Visible = true ;
             Label8->Visible = true ;
             Label9->Visible = true ;
         }
         else
         {
             Label6->Visible = false ;
             Label7->Visible = false ;
             Label8->Visible = false ;
             Label9->Visible = false ;
         }

}
//---------------------------------------------------------------------------

